/// Josh's User Interface Library
/// A C++20 Library for creating, styling, and rendering of a UI/UX widgets.
/// Developed and Maintained by Josh O'Leary @ Redacted Software.
/// Special Thanks to William Tomasine II and Maxine Hayes.
/// (c) 2024 Redacted Software
/// This work is dedicated to the public domain.

/// @file Window.hpp
/// @desc RadioButton Widget - Similar to Button, but remains 'pressed' until it is clicked again.
/// @edit 2024-07-13


#include <JUI/Widgets/Button.hpp>
#include <JUI/Mixins/Toggleable.hpp>

namespace JUI
{
    class RadioButton : public Button, public Toggleable
    {
    //public:
        //Event<> OnToggleOnEvent;
        //Event<> OnToggleOffEvent;
    public:
        RadioButton();
        explicit RadioButton(Widget* parent);
        ~RadioButton() override {};
    public:
        //virtual void OnToggleOn();
        //virtual void OnToggleOff();
        void OnClick(const J3ML::LinearAlgebra::Vector2 &mouse_pos, const JUI::MouseButton &btn) override;
        //void OnRelease(const J3ML::LinearAlgebra::Vector2 &mouse_pos, const JUI::MouseButton &bnt,
        //                            bool still_hovering) override;
        void Update(float delta) override;
    protected:
        //bool toggle = false;
    };
}