#include <JUI/JUI.hpp>

namespace JUI
{

    // TODO: This is duplicated here and in ReCaveGame::Loggers.cpp
    // Bring into jlog as utility functions.
    std::string format_timestamp(jlog::Timestamp ts) {
        return std::format(
                "{}-{}-{} {}:{}:{}.{}",
                ts.Year(),
                ts.Month(),
                ts.Day(),
                ts.Hour().count(),
                ts.Minute().count(),
                ts.Second().count(),
                ts.Millisecond().count());
    }

    // TODO: This is duplicated here and in ReCaveGame::Loggers.cpp
    // Bring into jlog as utility functions.
    std::string format_source_location(const std::source_location& location) {
        return std::format("{} @ {}:{}", location.function_name(), location.file_name(), location.line());
    }

    JUILogger::JUILogger(const std::string &context, std::ofstream &file, Color4 contextColor, Color4 timestampColor,
                         Color4 locationColor, Color4 pointerColor, Color4 messageColor)
            : jlog::GenericLogger(context, file, contextColor, timestampColor, locationColor, pointerColor, messageColor) { }

    void JUILogger::Log(const std::string &message, const std::source_location &location, const jlog::Timestamp &ts) {
        GenericLogger::Log(message, location, ts);

        std::string formatted_timestamp = format_timestamp(ts);
        std::string formatted_source_location = format_source_location(location);

        std::string final_result = std::format("[{}] [{}] []", formatted_timestamp, this->ConsoleLogger::context, message);

        OnLog.Invoke(final_result, messageColor);
    }

    std::ofstream GlobalLogFile("latest.log", std::ios_base::app);
    JUILogger UILogs {"JUI", GlobalLogFile, Colors::Green, Colors::Gray, Colors::Gray, Colors::Green, Colors::White};



}
