#include <JUI/Mixins/Pinnable.hpp>

namespace JUI {
    void Pinnable::Pin()   { SetPinned(true);  }
    void Pinnable::Unpin() { SetPinned(false); }
    bool Pinnable::Pinned() const { return pinned; }

    void Pinnable::OnPinStatusChanged(bool now_pinned) {
        if (now_pinned)
            OnPin();
        else
            OnUnpin();
    }

    void Pinnable::SetPinned(bool pinned) {
        if (pinned != this->pinned) {
            OnPinStatusChanged(pinned);
            this->pinned = pinned;
        }
    }
}