#include <JUI/Widgets/Image.hpp>

namespace JUI
{
    Image::Image() : Widget(), ImageBase() {
        Name("Image");
    }

    Image::Image(Widget* parent) : Image()
    {
        Parent(parent);
    }

    Image::Image(Widget *parent, JGL::Texture *tex) : Widget(), ImageBase(tex)
    {
        this->Parent(parent);
    }

    Vector2 Image::GetAbsoluteSize() const {
        return parent->GetAbsoluteSize();
    }

    Vector2 Image::GetAbsolutePosition() const {
        return parent->GetAbsolutePosition();
    }

    void Image::Draw() {
        // TODO: Factor in margin?

        if (fit_image_to_parent)
        {
            auto old_scale = scale;
            scale = GetAbsoluteSize() / Vector2(texture->GetDimensions());
            ImageBase::Draw(GetAbsolutePosition(), GetAbsoluteSize());
            scale = old_scale;
        } else
        {
            ImageBase::Draw(GetAbsolutePosition(), GetAbsoluteSize());
        }

        Widget::Draw();
    }

    void Image::Update(float delta) {
        Widget::Update(delta);
    }

    bool Image::FitImageToParent() const { return fit_image_to_parent; }

    void Image::FitImageToParent(bool on) { fit_image_to_parent = on; }
}