#include "JUI/Widgets/Scene.hpp"

namespace JUI {
    Scene::Scene(): Widget() {
        Name("Scene");
    }

    Vector2 Scene::GetAbsolutePosition() const { return {0,0};}

    Vector2 Scene::GetAbsoluteSize() const { return viewport_size / ui_scale;}

    void Scene::Draw() {

        J2D::Begin();

        glScalef(ui_scale.x, ui_scale.y, 0.f);
            Widget::Draw();
        J2D::End();

    }

    void Scene::Update(float delta) {
        Widget::Update(delta);

    }

    void Scene::GlobalUIScale(const Vector2 &value) { ui_scale = value;}

    Vector2 Scene::GlobalUIScale() const { return ui_scale; }

    bool Scene::ObserveMouseMovement(const Vector2 &latest_known_pos) {
        Vector2 new_pos = latest_known_pos / ui_scale;
        return Widget::ObserveMouseMovement(new_pos);
    }
}


