#include "JUI/Widgets/Text.hpp"


namespace JUI {
    Text::Text() : Widget(), TextBase() {
        Name("Text");
    }

    Text::Text(Widget* parent) : Text()
    {
        this->Parent(parent);
    }

    Text::~Text() {}
    Vector2 Text::GetAbsolutePosition() const {
        auto parent = this->GetParent();
        if (parent)
            return parent->GetAbsolutePosition();
        //return {0,0};
    }

    Vector2 Text::GetAbsoluteSize() const {
        auto parent = this->GetParent();
        if (parent)
            return parent->GetAbsoluteSize();
        //return {0, 0};
    }

    void Text::InnerDraw()
    {
        auto abs_pos = this->GetAbsolutePosition();
        auto abs_size = this->GetAbsoluteSize();

        auto pos_pad = GetAbsolutePaddingTopLeft();
        auto size_pad = GetAbsolutePaddingBottomRight();

        TextBase::Draw(abs_pos+pos_pad, abs_size-size_pad);

    }

    void Text::Draw() {
        Widget::Draw();
    }

    void Text::Update(float delta)
    {
        Widget::Update(delta);
    }

}